from lib.snabbdom import h

class CorpusExample:
    def __init__(self):
        self.other_attributes = {}
        self.original_xml = None
    
    def import_xml(self, example_xml):
        for oth_attr in ["example_id", "modified", "lexical_unit_id", "audio"]:
            if example_xml.hasAttribute(oth_attr):
                self.other_attributes[oth_attr] = example_xml.getAttribute(oth_attr)
        self.original_xml = example_xml
        example_xml.remove()

    def export(self, doc, modified):
        result = self.original_xml if self.original_xml is not None else doc.createElement("corpusExample")
        if modified:
            result.setAttribute("modified", "true")
            
        for key, value in self.other_attributes.items():
            result.setAttribute(key, value)
        return result
    
    def get_cluster(self):
        return None
    
    def get_structure(self):
        return None
    
    def view(self, components):
        return [h("span" + comp.view_style(), {}, comp.text) for comp in components]
    
