from model.data import Data

from lib.snabbdom import h


class Explanation(Data):
    def __init__(self):
        self.value = ""
        self.language = ""
        self.original_xml = None

    def import_dom(self, explanation_xml):
        self.original_xml = explanation_xml.cloneNode(True)
        self.value = explanation_xml.textContent if explanation_xml else ""
        self.language = explanation_xml.getAttribute("language") if explanation_xml.hasAttribute("language") else ""

    def export(self, doc):
        result = self.original_xml if self.original_xml != None else doc.createElement("explanation")
        result.textContent = self.value
        if self.language != "": result.setAttribute('language', self.language)

        return result
